"use strict";
this.name = "oolite-random-hits-autominer";
this.author = "LittleBear, Eric Walch & Thargoid";
this.copyright = "December 2008 - But do what you like with it in your OXPs!";
this.description	= "Stops miners trying to mine the asteroids with mining machines on them.";
this.licence     = "CC BY-NC-SA 3.0";
this.version = "2.1";

/*
The autominer no longer scans for the hopper. It now has just a dumb AI that is mainly idle. Not constant 
canning for the hopper saves cpu time. The hopper now finds its target and sends the autominer a
signel to proceed with its AI. After some tome the AI falls back to its idle state.
*/

this.shipSpawned = function ()
{
    this.ship.displayName = expandDescription("[random_hits_autominer_name]"); // Show the Victim's name on the ID Computer when targeted.
    delete this.shipSpawned;
}

this.shipDied = function ()
{
    var pods = Math.round(Math.random()*5);
    var splinters = Math.round(Math.random()*5);
    if (pods > 0) this.ship.spawn("random_hits_mining_pod2", pods);
    if (splinters > 0) this.ship.spawn("splinter", splinters);
}

this.shipBeingAttacked = function (who)
{
    if (!who) return;
    this.ship.bounty = 0;
    if (who.primaryRole === "random_hits_patrol" || who.primaryRole === "miner") 
    {
        who.target = null;
        who.reactToAIMessage("TARGET_LOST"); // Stops hunter or miner odd behaviour. 
        return;		
    }
	if (who.isPlayer) 
    {
        this.ship.reactToAIMessage("ENEMY_ATTACK"); 
        player.bounty |= 25;			
    }		
}

/*
Since 1.74 all missiles for a ship are already created when the mother ship is added to the system. Therefor the maximum
number a ship can carry is reduced. Also the ship gets a certain percentage random, real missiles. That is unwanted here, so  
we start with zero missiles in shipData.plist and add them here before use, so we are sure we fire the right stuff.
*/
this.dumpMiningPod = function () // called by an AI script message.
{
    this.ship.awardEquipment("random_hits_mining_pod_MISSILE"); // load a missile
    this.ship.fireMissile(); // and fire it.
}
