"use strict";
this.name = "oolite-random-hits-minesweeper";
this.author = "LittleBear, Eric Walch & Thargoid";
this.copyright = "November 2008 - But do what you like with it in your OXPs!";
this.description	= "Stops some rare silly NPC behaviour involving minesweepers! When jumping out after a battle hunters pick a random object to fly away from, having orientated in a random direction. This is just to stop them creating a wormhole right in front of a bar, which then any hunters launched fly straight into. For some reason I can't quite figure out, occasionally they fire at minesweepers with their rear gun whilst flying to jump distance. This looks silly so this script stops them. (scanclass is set to CLASS_CARGO to prevent miners firing at it but, class_cargo also prevent ships from finding it in a scan for a role.)";
this.licence     = "CC BY-NC-SA 3.0";
this.version = "2.1";

this.quirium = ["EQ_QC_MINE", "EQ_CASCADE_MISSILE", "EQ_LAW_MISSILE", "EQ_OVERRIDE_MISSILE", "energy-bomb", "RANDOM_HITS_MINE"];

this.shipBeingAttacked = function (who)
{
    if (!who) return;
    this.ship.bounty = 0
    if (who.primaryRole === "random_hits_patrol") 
    {
        log(this.name, "A patrol ship with target: "+who.target+" hit a minesweeper.");
        who.target = null;
        who.reactToAIMessage("LOST_TARGET"); // Stops hunter odd behaviour. 
        return;		
    }
    if (who.isPlayer) 
    {
        this.ship.reactToAIMessage("ENEMY_ATTACK"); 
        player.bounty |= 25;
    }		
}

this.doScan = function () 
{ 
	// create an array with all weapons in range.
	function allShips(entity) {return entity.isShip && entity.isWeapon}; 
	var missiles = system.filteredEntities(this, allShips, this.ship, this.ship.scannerRange);

    for (var i = 0; i < missiles.length; i++)
    {
        if (this.quirium.indexOf(missiles[i].primaryRole) > -1) 
        {
            this.ship.commsMessage(expandDescription("[random_hits_mine_found]"));
            missiles[i].explode();
            this.ship.fireECM();
            break; // found one
        }
    }
}

this.thargoidScan = function () 
{ 
	// create an array with all thargoids in range.
	function allShips(entity) {return entity.isShip && entity.isThargoid}; 
	var thargoids = system.filteredEntities(this, allShips, this.ship, this.ship.scannerRange);

    for (var i = 0; i < thargoids.length; i++)
    {
        if (thargoids[i].hasRole("secondWave_mineTharglet")) 
        {
            this.ship.commsMessage(expandDescription("[random_hits_mine_found2]"));
            thargoids[i].explode();
            this.ship.fireECM();
            break; // found one
        }
    }
}
